首頁 > web前端 > js教程 > 數組中第 K 大的元素

數組中第 K 大的元素

Mary-Kate Olsen
發布: 2024-09-24 06:16:01
原創
429 人瀏覽過

Kth Largest Element in an Array

#️⃣數組、優先佇列、快速選擇

https://leetcode.com/problems/kth-largest-element-in-an-array/description

?了解問題

如果陣列為 [8, 6, 12, 9, 3, 4] 且 k 為 2,則需要找出該陣列中第二大的元素。首先,您將對陣列進行排序: [3, 4, 6, 8, 9, 12] 輸出將為 9,因為它是第二大元素。

✅ 暴力破解

var findKthLargest = function(nums, k) {
    // Sort the array in ascending order
    nums.sort((a, b) => a - b);

    // Return the kth largest element
    return nums[nums.length - k];
};
登入後複製

解釋:

  1. 將陣列進行排序:使用sort方法對陣列進行升序排序。
  2. 找出第 k 個最大元素:透過存取索引 nums.length - k 處的元素來找出第 k 個最大元素。

時間複雜度:

  • 排序:對陣列進行排序的時間複雜度為 (O(nlog n)),其中 (n) 是陣列的長度。
  • 存取元素:存取陣列中的元素是 O(1)。

因此,總體時間複雜度為 O(n log n)。

空間複雜度:

  • 就地排序:排序方法對陣列進行就地排序,因此排序運算的空間複雜度為O(1)。
  • 總體:由於我們沒有使用任何額外的資料結構,因此總體空間複雜度為 O(1)。

✅ 更好

var findKthLargest = function(nums, k) {
        // Create a min-heap using a priority queue
        let minHeap = new MinPriorityQueue();

        // Add the first k elements to the heap
        for (let i = 0; i < k; i++) {
            //minHeap.enqueue(nums[i]): Adds the element nums[i] to the min-heap.
            minHeap.enqueue(nums[i]);
        }

        // Iterate through the remaining elements
        for (let i = k; i < nums.length; i++) {
            //minHeap.front().element: Retrieves the smallest element in the min-heap without removing it.
            if (minHeap.front().element < nums[i]) {
                // minHeap.dequeue(): Removes the smallest element from the min-heap.
                minHeap.dequeue();
                // Add the current element
                minHeap.enqueue(nums[i]);
            }
        }

        // The root of the heap is the kth largest element
        return minHeap.front().element;
    };
登入後複製

解釋:

  1. 初始陣列: [2, 1, 6, 3, 5, 4]
  2. k = 3:我們要找出第三大元素。

步驟 1:將前 k 個元素加入最小堆

  • 加 2 後的堆: [2]
  • 加上 1 後的堆: [1, 2]
  • 加 6 後的堆: [1, 2, 6]

第 2 步:迭代剩餘元素

  • 當前元素 = 3

    • 比較前的堆: [1, 2, 6]
    • 堆中最小的元素 (minHeap.front().element): 1
    • 比較:3> 1
    • 操作:刪除 1 並新增 3
    • 更新後的堆: [2, 6, 3]
  • 當前元素 = 5

    • 比較前的堆: [2, 6, 3]
    • 堆中最小的元素 (minHeap.front().element): 2
    • 比較:5> 2
    • 操作:刪除 2 並新增 5
    • 更新後的堆: [3, 6, 5]
  • 當前元素 = 4

    • 比較前的堆: [3, 6, 5]
    • 堆中最小的元素 (minHeap.front().element): 3
    • 比較:4> 3
    • 操作:刪除 3 並新增 4
    • 更新後的堆: [4, 6, 5]

最後一步:返回堆的根

  • : [4, 6, 5]
  • 第三大元素:4(堆的根)

時間複雜度:

  • 堆操作:從堆中插入和刪除元素需要 O(log k) 時間。
  • 總體:由於我們對數組中的 n 個元素中的每一個都執行這些操作,因此總體時間複雜度為 O(n log k)。

空間複雜度:

  • 堆疊儲存:空間複雜度為O(k),因為堆最多儲存k個元素。

✅ 最好的

注意:儘管 Leetcode 限制了快速選擇,但你應該記住這種方法,因為它通過了大多數測試用例

//Quick Select Algo

function quickSelect(list, left, right, k)

   if left = right
      return list[left]

   Select a pivotIndex between left and right

   pivotIndex := partition(list, left, right, 
                                  pivotIndex)
   if k = pivotIndex
      return list[k]
   else if k < pivotIndex
      right := pivotIndex - 1
   else
      left := pivotIndex + 1
登入後複製
var findKthLargest = function(nums, k) {
    // Call the quickSelect function to find the kth largest element
    return quickSelect(nums, 0, nums.length - 1, nums.length - k);
};

function quickSelect(nums, low, high, index) {
    // If the low and high pointers are the same, return the element at low
    if (low === high) return nums[low];

    // Partition the array and get the pivot index
    let pivotIndex = partition(nums, low, high);

    // If the pivot index is the target index, return the element at pivot index
    if (pivotIndex === index) {
        return nums[pivotIndex];
    } else if (pivotIndex > index) {
        // If the pivot index is greater than the target index, search in the left partition
        return quickSelect(nums, low, pivotIndex - 1, index);
    } else {
        // If the pivot index is less than the target index, search in the right partition
        return quickSelect(nums, pivotIndex + 1, high, index);
    }
}

function partition(nums, low, high) {
    // Choose the pivot element
    let pivot = nums[high];
    let pointer = low;

    // Rearrange the elements based on the pivot
    for (let i = low; i < high; i++) {
        if (nums[i] <= pivot) {
            [nums[i], nums[pointer]] = [nums[pointer], nums[i]];
            pointer++;
        }
    }

    // Place the pivot element in its correct position
    [nums[pointer], nums[high]] = [nums[high], nums[pointer]];
    return pointer;
}
登入後複製

Explanation:

  1. Initial Array: [3, 2, 1, 5, 6, 4]
  2. k = 2: We need to find the 2nd largest element.

Step 1: Partition the array

  • Pivot element = 4
  • Array after partitioning: [3, 2, 1, 4, 6, 5]
  • Pivot index = 3

Step 2: Recursive Selection

  • Target index = 4 (since we need the 2nd largest element, which is the 4th index in 0-based indexing)
  • Pivot index (3) < Target index (4): Search in the right partition [6, 5]

Step 3: Partition the right partition

  • Pivot element = 5
  • Array after partitioning: [3, 2, 1, 4, 5, 6]
  • Pivot index = 4

Final Step: Return the element at the target index

  • Element at index 4: 5

Time Complexity:

  • Average Case: The average time complexity of Quickselect is O(n).
  • Worst Case: The worst-case time complexity is O(n^2), but this is rare with good pivot selection.

Space Complexity:

  • In-Place: The space complexity is O(1) because the algorithm works in place.

以上是數組中第 K 大的元素的詳細內容。更多資訊請關注PHP中文網其他相關文章!

來源:dev.to
本網站聲明
本文內容由網友自願投稿,版權歸原作者所有。本站不承擔相應的法律責任。如發現涉嫌抄襲或侵權的內容,請聯絡admin@php.cn
作者最新文章
熱門教學
更多>
最新下載
更多>
網站特效
網站源碼
網站素材
前端模板